hdu 2489

                                      Minimal Ratio Tree

                  Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
                                         Total Submission(s): 5396    Accepted Submission(s): 1765


 

Problem Description

For a tree, which nodes and edges are all weighted, the ratio of it is calculated according to the following equation.
 



Given a complete graph of n nodes with all nodes and edges weighted, your task is to find a tree, which is a sub-graph of the original graph, with m nodes and whose ratio is the smallest among all the trees of m nodes in the graph.

Input

Input contains multiple test cases. The first line of each test case contains two integers n (2<=n<=15) and m (2<=m<=n), which stands for the number of nodes in the graph and the number of nodes in the minimal ratio tree. Two zeros end the input. The next line contains n numbers which stand for the weight of each node. The following n lines contain a diagonally symmetrical n×n connectivity matrix with each element shows the weight of the edge connecting one node with another. Of course, the diagonal will be all 0, since there is no edge connecting a node with itself.


All the weights of both nodes and edges (except for the ones on the diagonal of the matrix) are integers and in the range of [1, 100].

The figure below illustrates the first test case in sample input. Node 1 and Node 3 form the minimal ratio tree. 

Output

For each test case output one line contains a sequence of the m nodes which constructs the minimal ratio tree. Nodes should be arranged in ascending order. If there are several such sequences, pick the one which has the smallest node number; if there's a tie, look at the second smallest node number, etc. Please note that the nodes are numbered from 1 .

Sample Input

3 2
30 20 10
0 6 2
6 0 3
2 3 0
2 2
1 1
0 2
2 0
0 0

 

Sample Output

1 3
1 2

英文不好的很慌啊,总之题意就是从n个点中找出m个点,对这m个点进行最小生成树, 求最后 (All edgeWeight) / (All nodeWeight) 最小的那个树。可以用 dfs + prim 或者 dfs + kruskal,这里是后者

#include<iostream>
#include<memory.h>
#include<algorithm>
using namespace std;
struct edge{
	int s, t, w;
}e[10005];
int f[20], point[20], top = 0, flag[20], answer[20], n, m;
double ans;
int find(int x)
{
	return f[x] == x?x:f[x] = find(f[x]);
}
bool marge(int x, int y)
{
	int fx = find(x);
	int fy = find(y);
	if(fx != fy)
	{
		f[fx] = fy;
		return true;
	}
	return false;
}
int add(int s, int t, int w)
{
	e[top].s = t;
	e[top].t = s;
	e[top].w = w;
	top ++;
}
bool cmp(edge a, edge b)
{
	return a.w < b.w;
}

double kruskal()
{
	int t = 0;
	int pointVal = 0, edgeVal = 0;
	for(int i = 1;i <= 19;i ++) f[i] = i;
	for(int i = 1;i <= n;i ++)
	{
		if(flag[i])
			pointVal += point[i];
	}
	for(int i = 0;i < top && t < m - 1;i ++)
	{
		if(flag[e[i].s] && flag[e[i].t])
		{
			if(marge(e[i].s, e[i].t) == true)
			{
				edgeVal += e[i].w;
				t ++;
			}
		}

	}
	return edgeVal * 1.0 / pointVal;
}
void dfs(int u, int num)
{
    if(num > m) return; 
    if(u == n + 1)
    {
        if(num != m) return;
        double t = kruskal();

        if(t < ans)
        {
            ans = t;
            memcpy(answer, flag, sizeof(flag));
        }
        return;
    }
    flag[u] = 1;
    dfs(u + 1, num + 1);
    flag[u] = 0;
    dfs(u + 1, num);
}
int main()
{
	while(~scanf("%d%d", &n, &m) && (n + m))
	{
		top = 0;
		memset(answer, 0, sizeof(answer));
		memset(point, 0, sizeof(point));
		memset(flag, 0, sizeof(flag));
		ans = 1000000000;
		for(int i = 1;i <= n;i ++)
			scanf("%d", &point[i]);
		for(int i = 1;i <= n;i ++)
		{
			for(int j = 1;j <= n;j ++)
			{
				int t;
				scanf("%d", &t);
				if(j < i)
					add(i, j, t);
			}
		}
		sort(e, e + top, cmp);
		dfs(1, 0);
		bool t = true;
		for(int i = 0;i <= n;i ++)
		{
			if(answer[i])
			{
				if(t)
					printf("%d", i), t = false;
				else
					printf(" %d", i);
			}
		}
		printf("\n");
	}
}

猜你喜欢

转载自blog.csdn.net/qq_41695941/article/details/84669311